diff --git a/gcc/c/c-decl.c b/gcc/c/c-decl.c
index ed1dd28..a3d3267 100644
--- a/gcc/c/c-decl.c
+++ b/gcc/c/c-decl.c
@@ -1571,11 +1571,12 @@ pushtag (location_t loc, tree name, tree type)
 	  && (TYPE_MAIN_VARIANT (TREE_TYPE (b->decl))
 	      != TYPE_MAIN_VARIANT (type)))
 	{
-	  if (warning_at (loc, OPT_Wc___compat,
-			  ("using %qD as both a typedef and a tag is "
-			   "invalid in C++"), b->decl)
+	  diagnostic_group d;
+	  if (d.warning_at (loc, OPT_Wc___compat,
+			    ("using %qD as both a typedef and a tag is "
+			     "invalid in C++"), b->decl)
 	      && b->locus != UNKNOWN_LOCATION)
-	    inform (b->locus, "originally defined here");
+	    d.inform (b->locus, "originally defined here");
 	}
     }
 }
@@ -1684,7 +1685,8 @@ match_builtin_function_types (tree newtype, tree oldtype)
    mismatch involving an empty arglist vs a nonempty one and give clearer
    diagnostics.  */
 static void
-diagnose_arglist_conflict (tree newdecl, tree olddecl,
+diagnose_arglist_conflict (diagnostic_group *d,
+			   tree newdecl, tree olddecl,
 			   tree newtype, tree oldtype)
 {
   tree t;
@@ -1705,15 +1707,16 @@ diagnose_arglist_conflict (tree newdecl, tree olddecl,
       if (TREE_CHAIN (t) == NULL_TREE
 	  && TYPE_MAIN_VARIANT (type) != void_type_node)
 	{
-	  inform (input_location, "a parameter list with an ellipsis can%'t match "
-		  "an empty parameter name list declaration");
+	  d->inform (input_location, "a parameter list with an ellipsis can%'t "
+		     "match an empty parameter name list declaration");
 	  break;
 	}
 
       if (c_type_promotes_to (type) != type)
 	{
-	  inform (input_location, "an argument type that has a default promotion can%'t match "
-		  "an empty parameter name list declaration");
+	  d->inform (input_location, "an argument type that has a default "
+		     "promotion can%'t match an empty parameter name list "
+		     "declaration");
 	  break;
 	}
     }
@@ -1724,7 +1727,8 @@ diagnose_arglist_conflict (tree newdecl, tree olddecl,
    Diagnose inconsistencies in the argument list.  Returns TRUE if
    the prototype is compatible, FALSE if not.  */
 static bool
-validate_proto_after_old_defn (tree newdecl, tree newtype, tree oldtype)
+validate_proto_after_old_defn (tree newdecl, tree newtype, tree oldtype,
+			       diagnostic_group *d)
 {
   tree newargs, oldargs;
   int i;
@@ -1759,14 +1763,14 @@ validate_proto_after_old_defn (tree newdecl, tree newtype, tree oldtype)
 	 agree on the number of arguments.  */
       if (END_OF_ARGLIST (oldargtype))
 	{
-	  error ("prototype for %q+D declares more arguments "
-		 "than previous old-style definition", newdecl);
+	  d->error ("prototype for %q+D declares more arguments "
+		    "than previous old-style definition", newdecl);
 	  return false;
 	}
       else if (END_OF_ARGLIST (newargtype))
 	{
-	  error ("prototype for %q+D declares fewer arguments "
-		 "than previous old-style definition", newdecl);
+	  d->error ("prototype for %q+D declares fewer arguments "
+		    "than previous old-style definition", newdecl);
 	  return false;
 	}
 
@@ -1774,9 +1778,9 @@ validate_proto_after_old_defn (tree newdecl, tree newtype, tree oldtype)
 	 for the arg.  */
       else if (!comptypes (oldargtype, newargtype))
 	{
-	  error ("prototype for %q+D declares argument %d"
-		 " with incompatible type",
-		 newdecl, i);
+	  d->error ("prototype for %q+D declares argument %d"
+		    " with incompatible type",
+		    newdecl, i);
 	  return false;
 	}
 
@@ -1787,27 +1791,28 @@ validate_proto_after_old_defn (tree newdecl, tree newtype, tree oldtype)
 
   /* If we get here, no errors were found, but do issue a warning
      for this poor-style construct.  */
-  warning (0, "prototype for %q+D follows non-prototype definition",
-	   newdecl);
+  d->warning (0, "prototype for %q+D follows non-prototype definition",
+	      newdecl);
   return true;
 #undef END_OF_ARGLIST
 }
 
 /* Subroutine of diagnose_mismatched_decls.  Report the location of DECL,
    first in a pair of mismatched declarations, using the diagnostic
-   function DIAG.  */
+   group D.  */
 static void
-locate_old_decl (tree decl)
+locate_old_decl (tree decl, diagnostic_group *d)
 {
   if (TREE_CODE (decl) == FUNCTION_DECL && DECL_BUILT_IN (decl)
       && !C_DECL_DECLARED_BUILTIN (decl))
     ;
   else if (DECL_INITIAL (decl))
-    inform (input_location, "previous definition of %q+D was here", decl);
+    d->inform (input_location, "previous definition of %q+D was here", decl);
   else if (C_DECL_IMPLICIT (decl))
-    inform (input_location, "previous implicit declaration of %q+D was here", decl);
+    d->inform (input_location, "previous implicit declaration of %q+D was here",
+	      decl);
   else
-    inform (input_location, "previous declaration of %q+D was here", decl);
+    d->inform (input_location, "previous declaration of %q+D was here", decl);
 }
 
 /* Subroutine of duplicate_decls.  Compare NEWDECL to OLDDECL.
@@ -1823,8 +1828,6 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 			   tree *newtypep, tree *oldtypep)
 {
   tree newtype, oldtype;
-  bool pedwarned = false;
-  bool warned = false;
   bool retval = true;
 
 #define DECL_EXTERN_INLINE(DECL) (DECL_DECLARED_INLINE_P (DECL)  \
@@ -1847,8 +1850,9 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	    && DECL_BUILT_IN (olddecl)
 	    && !C_DECL_DECLARED_BUILTIN (olddecl)))
 	{
-	  error ("%q+D redeclared as different kind of symbol", newdecl);
-	  locate_old_decl (olddecl);
+	  diagnostic_group d;
+	  d.error ("%q+D redeclared as different kind of symbol", newdecl);
+	  locate_old_decl (olddecl, &d);
 	}
       else if (TREE_PUBLIC (newdecl))
 	warning (OPT_Wbuiltin_declaration_mismatch,
@@ -1864,11 +1868,16 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
      given scope.  */
   if (TREE_CODE (olddecl) == CONST_DECL)
     {
-      error ("redeclaration of enumerator %q+D", newdecl);
-      locate_old_decl (olddecl);
+      diagnostic_group d;
+      d.error ("redeclaration of enumerator %q+D", newdecl);
+      locate_old_decl (olddecl, &d);
       return false;
     }
 
+  bool pedwarned = false;
+  bool warned = false;
+  diagnostic_group d;
+
   if (!comptypes (oldtype, newtype))
     {
       if (TREE_CODE (olddecl) == FUNCTION_DECL
@@ -1910,8 +1919,8 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	       && TYPE_MAIN_VARIANT (TREE_TYPE (newtype)) == integer_type_node
 	       && C_FUNCTION_IMPLICIT_INT (newdecl) && !DECL_INITIAL (olddecl))
 	{
-	  pedwarned = pedwarn (input_location, 0,
-			       "conflicting types for %q+D", newdecl);
+	  pedwarned = d.pedwarn (input_location, 0,
+				 "conflicting types for %q+D", newdecl);
 	  /* Make sure we keep void as the return type.  */
 	  TREE_TYPE (newdecl) = *newtypep = newtype = oldtype;
 	  C_FUNCTION_IMPLICIT_INT (newdecl) = 0;
@@ -1923,8 +1932,8 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	       && TYPE_MAIN_VARIANT (TREE_TYPE (oldtype)) == integer_type_node
 	       && C_DECL_IMPLICIT (olddecl) && !DECL_INITIAL (olddecl))
 	{
-	  pedwarned = pedwarn (input_location, 0,
-			       "conflicting types for %q+D", newdecl);
+	  pedwarned = d.pedwarn (input_location, 0,
+				 "conflicting types for %q+D", newdecl);
 	  /* Make sure we keep void as the return type.  */
 	  TREE_TYPE (olddecl) = *oldtypep = oldtype = newtype;
 	}
@@ -1940,29 +1949,29 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	      if (new_addr != old_addr)
 		{
 		  if (ADDR_SPACE_GENERIC_P (new_addr))
-		    error ("conflicting named address spaces (generic vs %s) "
-			   "for %q+D",
-			   c_addr_space_name (old_addr), newdecl);
+		    d.error ("conflicting named address spaces (generic vs %s) "
+			     "for %q+D",
+			     c_addr_space_name (old_addr), newdecl);
 		  else if (ADDR_SPACE_GENERIC_P (old_addr))
-		    error ("conflicting named address spaces (%s vs generic) "
-			   "for %q+D",
-			   c_addr_space_name (new_addr), newdecl);
+		    d.error ("conflicting named address spaces (%s vs generic) "
+			     "for %q+D",
+			     c_addr_space_name (new_addr), newdecl);
 		  else
-		    error ("conflicting named address spaces (%s vs %s) "
-			   "for %q+D",
-			   c_addr_space_name (new_addr),
-			   c_addr_space_name (old_addr),
-			   newdecl);
+		    d.error ("conflicting named address spaces (%s vs %s) "
+			     "for %q+D",
+			     c_addr_space_name (new_addr),
+			     c_addr_space_name (old_addr),
+			     newdecl);
 		}
 
 	      if (CLEAR_QUAL_ADDR_SPACE (new_quals)
 		  != CLEAR_QUAL_ADDR_SPACE (old_quals))
-		error ("conflicting type qualifiers for %q+D", newdecl);
+		d.error ("conflicting type qualifiers for %q+D", newdecl);
 	    }
 	  else
-	    error ("conflicting types for %q+D", newdecl);
-	  diagnose_arglist_conflict (newdecl, olddecl, newtype, oldtype);
-	  locate_old_decl (olddecl);
+	    d.error ("conflicting types for %q+D", newdecl);
+	  diagnose_arglist_conflict (&d, newdecl, olddecl, newtype, oldtype);
+	  locate_old_decl (olddecl, &d);
 	  return false;
 	}
     }
@@ -1982,8 +1991,8 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 
       if (comptypes_result != 1 || types_different)
 	{
-	  error ("redefinition of typedef %q+D with different type", newdecl);
-	  locate_old_decl (olddecl);
+	  d.error ("redefinition of typedef %q+D with different type", newdecl);
+	  locate_old_decl (olddecl, &d);
 	  return false;
 	}
 
@@ -1995,13 +2004,17 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 
       if (variably_modified_type_p (newtype, NULL))
 	{
-	  error ("redefinition of typedef %q+D with variably modified type",
+	  d.error ("redefinition of typedef %q+D with variably modified type",
 		 newdecl);
-	  locate_old_decl (olddecl);
+	  locate_old_decl (olddecl, &d);
+	}
+      else
+	{
+	  // FIXME: use d here:
+	  if (pedwarn_c99 (input_location, OPT_Wpedantic,
+			   "redefinition of typedef %q+D", newdecl))
+	    locate_old_decl (olddecl, &d);
 	}
-      else if (pedwarn_c99 (input_location, OPT_Wpedantic,
-			    "redefinition of typedef %q+D", newdecl))
-	locate_old_decl (olddecl);
 
       return true;
     }
@@ -2052,8 +2065,9 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 		  )
 		  && same_translation_unit_p (newdecl, olddecl))
 		{
-		  error ("redefinition of %q+D", newdecl);
-		  locate_old_decl (olddecl);
+		  diagnostic_group d;
+		  d.error ("redefinition of %q+D", newdecl);
+		  locate_old_decl (olddecl, &d);
 		  return false;
 		}
 	    }
@@ -2062,11 +2076,14 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	 the argument types must be checked specially.  */
       else if (DECL_INITIAL (olddecl)
 	       && !prototype_p (oldtype) && prototype_p (newtype)
-	       && TYPE_ACTUAL_ARG_TYPES (oldtype)
-	       && !validate_proto_after_old_defn (newdecl, newtype, oldtype))
+	       && TYPE_ACTUAL_ARG_TYPES (oldtype))
 	{
-	  locate_old_decl (olddecl);
-	  return false;
+	  diagnostic_group d;
+	  if (!validate_proto_after_old_defn (newdecl, newtype, oldtype, &d))
+	    {
+	      locate_old_decl (olddecl, &d);
+	      return false;
+	    }
 	}
       /* A non-static declaration (even an "extern") followed by a
 	 static declaration is undefined behavior per C99 6.2.2p3-5,7.
@@ -2087,9 +2104,10 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	  if (!DECL_IS_BUILTIN (olddecl)
 	      && !DECL_EXTERN_INLINE (olddecl))
 	    {
-	      error ("static declaration of %q+D follows "
-		     "non-static declaration", newdecl);
-	      locate_old_decl (olddecl);
+	      diagnostic_group d;
+	      d.error ("static declaration of %q+D follows "
+		       "non-static declaration", newdecl);
+	      locate_old_decl (olddecl, &d);
 	    }
 	  return false;
 	}
@@ -2097,16 +2115,17 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	{
 	  if (DECL_CONTEXT (olddecl))
 	    {
+	      diagnostic_group d;
 	      error ("non-static declaration of %q+D follows "
 		     "static declaration", newdecl);
-	      locate_old_decl (olddecl);
+	      locate_old_decl (olddecl, &d);
 	      return false;
 	    }
 	  else if (warn_traditional)
 	    {
-	      warned |= warning (OPT_Wtraditional,
-				 "non-static declaration of %q+D "
-				 "follows static declaration", newdecl);
+	      warned |= d.warning (OPT_Wtraditional,
+				   "non-static declaration of %q+D "
+				   "follows static declaration", newdecl);
 	    }
 	}
 
@@ -2121,10 +2140,12 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 					DECL_ATTRIBUTES (olddecl)) != NULL;
 	  if (newa != olda)
 	    {
-	      error_at (input_location, "%<gnu_inline%> attribute present on %q+D",
-			newa ? newdecl : olddecl);
-	      error_at (DECL_SOURCE_LOCATION (newa ? olddecl : newdecl),
-			"but not here");
+	      diagnostic_group d;
+	      d.error_at (input_location,
+			  "%<gnu_inline%> attribute present on %q+D",
+			  newa ? newdecl : olddecl);
+	      d.error_at (DECL_SOURCE_LOCATION (newa ? olddecl : newdecl),
+			  "but not here");
 	    }
 	}
     }
@@ -2141,22 +2162,24 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	}
       else if (DECL_THREAD_LOCAL_P (newdecl) != DECL_THREAD_LOCAL_P (olddecl))
 	{
+	  diagnostic_group d;
 	  if (DECL_THREAD_LOCAL_P (newdecl))
-	    error ("thread-local declaration of %q+D follows "
-		   "non-thread-local declaration", newdecl);
+	    d.error ("thread-local declaration of %q+D follows "
+		     "non-thread-local declaration", newdecl);
 	  else
-	    error ("non-thread-local declaration of %q+D follows "
-		   "thread-local declaration", newdecl);
+	    d.error ("non-thread-local declaration of %q+D follows "
+		     "thread-local declaration", newdecl);
 
-	  locate_old_decl (olddecl);
+	  locate_old_decl (olddecl, &d);
 	  return false;
 	}
 
       /* Multiple initialized definitions are not allowed (6.9p3,5).  */
       if (DECL_INITIAL (newdecl) && DECL_INITIAL (olddecl))
 	{
-	  error ("redefinition of %q+D", newdecl);
-	  locate_old_decl (olddecl);
+	  diagnostic_group d;
+	  d.error ("redefinition of %q+D", newdecl);
+	  locate_old_decl (olddecl, &d);
 	  return false;
 	}
 
@@ -2175,28 +2198,30 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	    {
 	      if (!DECL_FILE_SCOPE_P (olddecl))
 		{
-		  error ("extern declaration of %q+D follows "
-			 "declaration with no linkage", newdecl);
-		  locate_old_decl (olddecl);
+		  diagnostic_group d;
+		  d.error ("extern declaration of %q+D follows "
+			   "declaration with no linkage", newdecl);
+		  locate_old_decl (olddecl, &d);
 		  return false;
 		}
 	      else if (warn_traditional)
 		{
-		  warned |= warning (OPT_Wtraditional,
-				     "non-static declaration of %q+D "
-				     "follows static declaration", newdecl);
+		  warned |= d.warning (OPT_Wtraditional,
+				       "non-static declaration of %q+D "
+				       "follows static declaration", newdecl);
 		}
 	    }
 	  else
 	    {
+	      diagnostic_group d;
 	      if (TREE_PUBLIC (newdecl))
-		error ("non-static declaration of %q+D follows "
-		       "static declaration", newdecl);
+		d.error ("non-static declaration of %q+D follows "
+			 "static declaration", newdecl);
 	      else
-		error ("static declaration of %q+D follows "
-		       "non-static declaration", newdecl);
+		d.error ("static declaration of %q+D follows "
+			 "non-static declaration", newdecl);
 
-	      locate_old_decl (olddecl);
+	      locate_old_decl (olddecl, &d);
 	      return false;
 	    }
 	}
@@ -2211,14 +2236,16 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	    }
 	  else if (DECL_EXTERNAL (olddecl))
 	    {
-	      error ("declaration of %q+D with no linkage follows "
-		     "extern declaration", newdecl);
-	      locate_old_decl (olddecl);
+	      diagnostic_group d;
+	      d.error ("declaration of %q+D with no linkage follows "
+		       "extern declaration", newdecl);
+	      locate_old_decl (olddecl, &d);
 	    }
 	  else
 	    {
-	      error ("redeclaration of %q+D with no linkage", newdecl);
-	      locate_old_decl (olddecl);
+	      diagnostic_group d;
+	      d.error ("redeclaration of %q+D with no linkage", newdecl);
+	      locate_old_decl (olddecl, &d);
 	    }
 
 	  return false;
@@ -2230,11 +2257,11 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	  && DECL_FILE_SCOPE_P (newdecl)
 	  && !DECL_EXTERNAL (newdecl)
 	  && !DECL_EXTERNAL (olddecl))
-	warned |= warning_at (DECL_SOURCE_LOCATION (newdecl),
-			      OPT_Wc___compat,
-			      ("duplicate declaration of %qD is "
-			       "invalid in C++"),
-			      newdecl);
+	warned |= d.warning_at (DECL_SOURCE_LOCATION (newdecl),
+				OPT_Wc___compat,
+				("duplicate declaration of %qD is "
+				 "invalid in C++"),
+				newdecl);
     }
 
   /* warnings */
@@ -2243,8 +2270,8 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
       && DECL_VISIBILITY_SPECIFIED (newdecl) && DECL_VISIBILITY_SPECIFIED (olddecl)
       && DECL_VISIBILITY (newdecl) != DECL_VISIBILITY (olddecl))
     {
-      warned |= warning (0, "redeclaration of %q+D with different visibility "
-			 "(old visibility preserved)", newdecl);
+      warned |= d.warning (0, "redeclaration of %q+D with different visibility "
+			   "(old visibility preserved)", newdecl);
     }
 
   if (TREE_CODE (newdecl) == FUNCTION_DECL)
@@ -2263,8 +2290,9 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
       if (TREE_CODE (newdecl) == PARM_DECL
 	  && (!TREE_ASM_WRITTEN (olddecl) || TREE_ASM_WRITTEN (newdecl)))
 	{
-	  error ("redefinition of parameter %q+D", newdecl);
-	  locate_old_decl (olddecl);
+	  diagnostic_group d;
+	  d.error ("redefinition of parameter %q+D", newdecl);
+	  locate_old_decl (olddecl, &d);
 	  return false;
 	}
     }
@@ -2290,13 +2318,14 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
       && !(VAR_P (newdecl)
 	   && DECL_INITIAL (newdecl) && !DECL_INITIAL (olddecl)))
     {
-      warned = warning (OPT_Wredundant_decls, "redundant redeclaration of %q+D",
-			newdecl);
+      warned = d.warning (OPT_Wredundant_decls,
+			  "redundant redeclaration of %q+D",
+			  newdecl);
     }
 
   /* Report location of previous decl/defn.  */
   if (warned || pedwarned)
-    locate_old_decl (olddecl);
+    locate_old_decl (olddecl, &d);
 
 #undef DECL_EXTERN_INLINE
 
@@ -2778,7 +2807,6 @@ warn_if_shadowing (tree new_decl)
 					     DECL_SOURCE_LOCATION (b->decl))))
       {
 	tree old_decl = b->decl;
-	bool warned = false;
 
 	if (old_decl == error_mark_node)
 	  {
@@ -2786,7 +2814,10 @@ warn_if_shadowing (tree new_decl)
 		     "non-variable", new_decl);
 	    break;
 	  }
-	else if (TREE_CODE (old_decl) == PARM_DECL)
+
+	bool warned = false;
+	diagnostic_group d;
+	if (TREE_CODE (old_decl) == PARM_DECL)
 	  {
 	    enum opt_code warning_code;
 
@@ -2800,9 +2831,10 @@ warn_if_shadowing (tree new_decl)
 	      warning_code = OPT_Wshadow_compatible_local;
 	    else
 	      warning_code = OPT_Wshadow_local;
-	    warned = warning_at (DECL_SOURCE_LOCATION (new_decl), warning_code,
-				 "declaration of %qD shadows a parameter",
-				 new_decl);
+	    warned = d.warning_at (DECL_SOURCE_LOCATION (new_decl),
+				   warning_code,
+				   "declaration of %qD shadows a parameter",
+				   new_decl);
 	  }
 	else if (DECL_FILE_SCOPE_P (old_decl))
 	  {
@@ -2813,10 +2845,10 @@ warn_if_shadowing (tree new_decl)
 		&& !FUNCTION_POINTER_TYPE_P (TREE_TYPE (new_decl)))
 		continue;
 
-	    warned = warning_at (DECL_SOURCE_LOCATION (new_decl), OPT_Wshadow,
-				 "declaration of %qD shadows a global "
-				 "declaration",
-				 new_decl);
+	    warned = d.warning_at (DECL_SOURCE_LOCATION (new_decl), OPT_Wshadow,
+				   "declaration of %qD shadows a global "
+				   "declaration",
+				   new_decl);
 	  }
 	else if (TREE_CODE (old_decl) == FUNCTION_DECL
 		 && DECL_BUILT_IN (old_decl))
@@ -2839,14 +2871,16 @@ warn_if_shadowing (tree new_decl)
 	      warning_code = OPT_Wshadow_compatible_local;
 	    else
 	      warning_code = OPT_Wshadow_local;
-	    warned = warning_at (DECL_SOURCE_LOCATION (new_decl), warning_code,
-				 "declaration of %qD shadows a previous local",
-				 new_decl);
+	    warned = d.warning_at (DECL_SOURCE_LOCATION (new_decl),
+				   warning_code,
+				   "declaration of %qD shadows a previous "
+				   "local",
+				   new_decl);
 	  }
 
 	if (warned)
-	  inform (DECL_SOURCE_LOCATION (old_decl),
-		  "shadowed declaration is here");
+	  d.inform (DECL_SOURCE_LOCATION (old_decl),
+		    "shadowed declaration is here");
 
 	break;
       }
@@ -3123,9 +3157,10 @@ implicit_decl_warning (location_t loc, tree id, tree olddecl)
     return;
 
   bool warned;
+  diagnostic_group d;
   name_hint hint;
   if (!olddecl)
-    hint = lookup_name_fuzzy (id, FUZZY_LOOKUP_FUNCTION_NAME, loc);
+    hint = lookup_name_fuzzy (id, FUZZY_LOOKUP_FUNCTION_NAME, &d, loc);
 
   if (flag_isoc99)
     {
@@ -3133,30 +3168,30 @@ implicit_decl_warning (location_t loc, tree id, tree olddecl)
 	{
 	  gcc_rich_location richloc (loc);
 	  richloc.add_fixit_replace (hint.suggestion ());
-	  warned = pedwarn (&richloc, OPT_Wimplicit_function_declaration,
-			    "implicit declaration of function %qE;"
-			    " did you mean %qs?",
-			    id, hint.suggestion ());
+	  warned = d.pedwarn (&richloc, OPT_Wimplicit_function_declaration,
+			      "implicit declaration of function %qE;"
+			      " did you mean %qs?",
+			      id, hint.suggestion ());
 	}
       else
-	warned = pedwarn (loc, OPT_Wimplicit_function_declaration,
-			  "implicit declaration of function %qE", id);
+	warned = d.pedwarn (loc, OPT_Wimplicit_function_declaration,
+			    "implicit declaration of function %qE", id);
     }
   else if (hint)
     {
       gcc_rich_location richloc (loc);
       richloc.add_fixit_replace (hint.suggestion ());
-      warned = warning_at
+      warned = d.warning_at
 	(&richloc, OPT_Wimplicit_function_declaration,
 	 G_("implicit declaration of function %qE; did you mean %qs?"),
 	 id, hint.suggestion ());
     }
   else
-    warned = warning_at (loc, OPT_Wimplicit_function_declaration,
-			 G_("implicit declaration of function %qE"), id);
+    warned = d.warning_at (loc, OPT_Wimplicit_function_declaration,
+			   G_("implicit declaration of function %qE"), id);
 
   if (olddecl && warned)
-    locate_old_decl (olddecl);
+    locate_old_decl (olddecl, &d);
 
   if (!warned)
     hint.suppress ();
@@ -3435,9 +3470,10 @@ implicitly_declare (location_t loc, tree functionid)
 	    {
 	      if (!comptypes (newtype, TREE_TYPE (decl)))
 		{
-		  error_at (loc, "incompatible implicit declaration of "
-			    "function %qD", decl);
-		  locate_old_decl (decl);
+		  diagnostic_group d;
+		  d.error_at (loc, "incompatible implicit declaration of "
+			      "function %qD", decl);
+		  locate_old_decl (decl, &d);
 		}
 	    }
 	  b->u.type = TREE_TYPE (decl);
@@ -3487,43 +3523,45 @@ undeclared_variable (location_t loc, tree id)
   static bool already = false;
   struct c_scope *scope;
 
+  diagnostic_group d;
   if (current_function_decl == NULL_TREE)
     {
-      name_hint guessed_id = lookup_name_fuzzy (id, FUZZY_LOOKUP_NAME, loc);
+      name_hint guessed_id = lookup_name_fuzzy (id, FUZZY_LOOKUP_NAME, &d, loc);
       if (guessed_id)
 	{
 	  gcc_rich_location richloc (loc);
 	  richloc.add_fixit_replace (guessed_id.suggestion ());
-	  error_at (&richloc,
-		    "%qE undeclared here (not in a function);"
-		    " did you mean %qs?",
-		    id, guessed_id.suggestion ());
+	  d.error_at (&richloc,
+		      "%qE undeclared here (not in a function);"
+		      " did you mean %qs?",
+		      id, guessed_id.suggestion ());
 	}
       else
-	error_at (loc, "%qE undeclared here (not in a function)", id);
+	d.error_at (loc, "%qE undeclared here (not in a function)", id);
       scope = current_scope;
     }
   else
     {
       if (!objc_diagnose_private_ivar (id))
 	{
-	  name_hint guessed_id = lookup_name_fuzzy (id, FUZZY_LOOKUP_NAME, loc);
+	  name_hint guessed_id = lookup_name_fuzzy (id, FUZZY_LOOKUP_NAME, &d,
+						    loc);
 	  if (guessed_id)
 	    {
 	      gcc_rich_location richloc (loc);
 	      richloc.add_fixit_replace (guessed_id.suggestion ());
-	      error_at (&richloc,
-			"%qE undeclared (first use in this function);"
-			" did you mean %qs?",
-			id, guessed_id.suggestion ());
+	      d.error_at (&richloc,
+			  "%qE undeclared (first use in this function);"
+			  " did you mean %qs?",
+			  id, guessed_id.suggestion ());
 	    }
 	  else
-	    error_at (loc, "%qE undeclared (first use in this function)", id);
+	    d.error_at (loc, "%qE undeclared (first use in this function)", id);
 	}
       if (!already)
 	{
-          inform (loc, "each undeclared identifier is reported only"
-                  " once for each function it appears in");
+	  d.inform (loc, "each undeclared identifier is reported only"
+		    " once for each function it appears in");
 	  already = true;
 	}
 
@@ -3686,8 +3724,9 @@ declare_label (tree name)
      at this scope */
   if (b && B_IN_CURRENT_SCOPE (b))
     {
-      error ("duplicate label declaration %qE", name);
-      locate_old_decl (b->decl);
+      diagnostic_group d;
+      d.error ("duplicate label declaration %qE", name);
+      locate_old_decl (b->decl, &d);
 
       /* Just use the previous declaration.  */
       return b->decl;
@@ -3784,8 +3823,9 @@ define_label (location_t location, tree name)
 	  || (DECL_CONTEXT (label) != current_function_decl
 	      && C_DECLARED_LABEL_FLAG (label))))
     {
-      error_at (location, "duplicate label %qD", label);
-      locate_old_decl (label);
+      diagnostic_group d;
+      d.error_at (location, "duplicate label %qD", label);
+      locate_old_decl (label, &d);
       return NULL_TREE;
     }
   else if (label && DECL_CONTEXT (label) == current_function_decl)
@@ -4026,10 +4066,11 @@ lookup_name_in_scope (tree name, struct c_scope *scope)
    It also looks for start_typename keywords, to detect "singed" vs "signed"
    typos.
 
-   Use LOC for any deferred diagnostics.  */
+   Use GROUP and LOC for any deferred diagnostics.  */
 
 name_hint
-lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind, location_t loc)
+lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind,
+		   diagnostic_group *group, location_t loc)
 {
   gcc_assert (TREE_CODE (name) == IDENTIFIER_NODE);
 
@@ -4040,7 +4081,7 @@ lookup_name_fuzzy (tree name, enum lookup_name_fuzzy_kind kind, location_t loc)
 
   if (header_hint)
     return name_hint (NULL,
-		      new suggest_missing_header (loc,
+		      new suggest_missing_header (group, loc,
 						  IDENTIFIER_POINTER (name),
 						  header_hint));
 
@@ -6727,11 +6768,12 @@ grokdeclarator (const struct c_declarator *declarator,
 		  || (current_scope == file_scope && B_IN_EXTERNAL_SCOPE (b)))
 	      && TYPE_MAIN_VARIANT (b->decl) != TYPE_MAIN_VARIANT (type))
 	    {
-	      if (warning_at (declarator->id_loc, OPT_Wc___compat,
-			      ("using %qD as both a typedef and a tag is "
-			       "invalid in C++"), decl)
+	      diagnostic_group d;
+	      if (d.warning_at (declarator->id_loc, OPT_Wc___compat,
+				("using %qD as both a typedef and a tag is "
+				 "invalid in C++"), decl)
 		  && b->locus != UNKNOWN_LOCATION)
-		inform (b->locus, "originally defined here");
+		d.inform (b->locus, "originally defined here");
 	    }
 	}
 
@@ -8801,9 +8843,10 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
 	{
 	  if (stdarg_p (TREE_TYPE (old_decl)))
 	    {
-	      warning_at (loc, 0, "%q+D defined as variadic function "
-			  "without prototype", decl1);
-	      locate_old_decl (old_decl);
+	      diagnostic_group d;
+	      d.warning_at (loc, 0, "%q+D defined as variadic function "
+			    "without prototype", decl1);
+	      locate_old_decl (old_decl, &d);
 	    }
 	  TREE_TYPE (decl1) = composite_type (TREE_TYPE (old_decl),
 					      TREE_TYPE (decl1));
diff --git a/gcc/c/c-parser.c b/gcc/c/c-parser.c
index 7a92628..bee318d 100644
--- a/gcc/c/c-parser.c
+++ b/gcc/c/c-parser.c
@@ -1814,17 +1814,18 @@ c_parser_declaration_or_fndef (c_parser *parser, bool fndef_ok,
 	}
       else
 	{
+	  diagnostic_group d;
 	  name_hint hint = lookup_name_fuzzy (name, FUZZY_LOOKUP_TYPENAME,
-					      here);
+					      &d, here);
 	  if (hint)
 	    {
 	      richloc.add_fixit_replace (hint.suggestion ());
-	      error_at (&richloc,
-			"unknown type name %qE; did you mean %qs?",
-			name, hint.suggestion ());
+	      d.error_at (&richloc,
+			  "unknown type name %qE; did you mean %qs?",
+			  name, hint.suggestion ());
 	    }
 	  else
-	    error_at (here, "unknown type name %qE", name);
+	    d.error_at (here, "unknown type name %qE", name);
 	}
 
       /* Parse declspecs normally to get a correct pointer type, but avoid
@@ -4049,19 +4050,20 @@ c_parser_parameter_declaration (c_parser *parser, tree attrs)
       c_parser_set_source_position_from_token (token);
       if (c_parser_next_tokens_start_typename (parser, cla_prefer_type))
 	{
+	  diagnostic_group d;
 	  name_hint hint = lookup_name_fuzzy (token->value,
 					      FUZZY_LOOKUP_TYPENAME,
-					      token->location);
+					      &d, token->location);
 	  if (hint)
 	    {
 	      gcc_rich_location richloc (token->location);
 	      richloc.add_fixit_replace (hint.suggestion ());
-	      error_at (&richloc,
-			"unknown type name %qE; did you mean %qs?",
-			token->value, hint.suggestion ());
+	      d.error_at (&richloc,
+			  "unknown type name %qE; did you mean %qs?",
+			  token->value, hint.suggestion ());
 	    }
 	  else
-	    error_at (token->location, "unknown type name %qE", token->value);
+	    d.error_at (token->location, "unknown type name %qE", token->value);
 	  parser->error = true;
 	}
       /* ??? In some Objective-C cases '...' isn't applicable so there
@@ -6864,14 +6866,18 @@ c_parser_binary_expression (c_parser *parser, struct c_expr *after,
 		&& !(TREE_CODE (first_arg) == PARM_DECL			      \
 		     && C_ARRAY_PARAMETER (first_arg)			      \
 		     && warn_sizeof_array_argument))			      \
-	      if (warning_at (stack[sp].loc, OPT_Wsizeof_pointer_div,	      \
-			      "division %<sizeof (%T) / sizeof (%T)%> does "  \
-			      "not compute the number of array elements",     \
-			      type0, type1))				      \
-		if (DECL_P (first_arg))					      \
-		  inform (DECL_SOURCE_LOCATION (first_arg),		      \
-			  "first %<sizeof%> operand was declared here");      \
-	  }								      \
+	      {								\
+		diagnostic_group d;					\
+		if (d.warning_at (stack[sp].loc, OPT_Wsizeof_pointer_div, \
+				  "division %<sizeof (%T) / sizeof (%T)%> " \
+				  "does not compute the number of array " \
+				  "elements",				\
+				  type0, type1))			\
+		  if (DECL_P (first_arg))				\
+		    d.inform (DECL_SOURCE_LOCATION (first_arg),		\
+			      "first %<sizeof%> operand was declared here"); \
+	      }								\
+	  }								\
 	break;								      \
       default:								      \
 	break;								      \
